<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Node-State Graph</title>
    <style>
        body,
        html,
        #graph {
            width: 100%;
            height: 100%;
            max-width: 100%;
            overflow: hidden;
        }

        body {
            margin: 0;
        }

        .text {
            font: 7px sans-serif;
        }

        .text-small {
            font: 4px sans-serif;
        }

        .edgelabel-tspan:hover {
            fill: #b80f0a;
            cursor: pointer;
        }
    </style>
</head>
<body>
<div id="graph"></div>

<script src="https://d3js.org/d3.v4.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/dagre/0.8.5/dagre.min.js"></script>

<script>
    const filterLinks = (data) => {
        let filteredLinks = [];
        data.links.forEach((link) => {
            if (filteredLinks.find((x) => x.source === link.target && x.target === link.source) === undefined)
                filteredLinks.push(link);
        });
        data.links = filteredLinks;
    };
    const prepareData = (data) => {
        const nodesByName = {};

        data.nodes.forEach((d) => {
            nodesByName[d.label] = d;
        });

        data.links.forEach((link) => {
            link.source = nodesByName[link.source];
            link.target = nodesByName[link.target];

            if (!link.source.links)
                link.source.links = [];

            link.source.links.push(link.target);
        });

        return nodesByName;
    };
    const setPositions = (data) => {
        const xDistance = 70;
        const yDistance = 70;

        let dagreGraph = new dagre.graphlib.Graph();
        dagreGraph.setGraph({
            'nodesep': xDistance,
            'ranksep': yDistance
        });
        dagreGraph.setDefaultEdgeLabel(() => ({}));
        data.nodes.forEach(x => {
            dagreGraph.setNode(x.id, {label: x.label, width: 5, height: 5});
        });
        data.links.forEach(link => {
            dagreGraph.setEdge(link.source.id, link.target.id, {weight: link.value, label: link.label});
        });
        dagre.layout(dagreGraph);

        dagreGraph.nodes().forEach(v => {
            const nodeInfo = dagreGraph.node(v);
            nodesByName[v].x = nodeInfo.x;
            nodesByName[v].y = nodeInfo.y;
        });

        const links = [];
        dagreGraph.edges().forEach((e) => {
            const link = {
                source: nodesByName[e.v],
                target: nodesByName[e.w],
                path: dagreGraph.edge(e).points,
                label: dagreGraph.edge(e).label
            };

            links.push(link);
        });

        let [minX, maxX, maxY] = findCoordLimits(data.nodes, links);
        return [minX, maxX, maxY, links];
    };
    const findCoordLimits = (nodes, links) => {
        let maxX = -Infinity;
        let maxY = -Infinity;
        let minX = Infinity;

        nodes.forEach(item => {
            if (item.x > maxX) maxX = item.x;
            if (item.x < minX) minX = item.x;
            if (item.y > maxY) maxY = item.y;
        });

        links.forEach(link => {
            for (let i = 0; i < link.path.length; ++i) {
                if (link.path[i].x > maxX) maxX = link.path[i].x;
                if (link.path[i].x < minX) minX = link.path[i].x;
            }
        });

        return [minX, maxX, maxY + 10];
    };
    const getNeighbors = (data, node) => {
        return data.links.reduce((neighbors, link) => {
            if (link.target.id === node.id) {
                neighbors.push(link.source.id)
            } else if (link.source.id === node.id) {
                neighbors.push(link.target.id)
            }
            return neighbors
        }, [node.id])
    };
    const getNodeNumber = (name) => {
        const nodeName = name.split("_");
        const nodeType = nodeName.shift();

        let lastValue = nodeName.pop();
        if (lastValue.search('-') !== -1)
            lastValue = lastValue.split('-')[0];

        nodeName.push(lastValue);

        const nodeNumber = parseInt(nodeName.join(""));
        const lastNumber = parseInt(nodeName[2]);

        return [nodeType, nodeNumber, lastNumber];
    };
    const getNodeRound = (name) => {
        const splitName = name.split('-');
        return (splitName.length > 1) ? parseInt(splitName[1]) : 0;
    };
</script>
<script>
    const tofColors = ["#78b5d8", "#76b4d8", "#75b3d7", "#73b2d7", "#72b1d7", "#70b0d6", "#6fafd6", "#6daed5", "#6caed5", "#6badd5", "#69acd4", "#68abd4", "#66aad3", "#65a9d3", "#63a8d2", "#62a7d2", "#61a7d1", "#5fa6d1", "#5ea5d0", "#5da4d0", "#5ba3d0", "#5aa2cf", "#59a1cf", "#57a0ce", "#569fce", "#559ecd", "#549ecd", "#529dcc", "#519ccc", "#509bcb", "#4f9acb", "#4d99ca", "#4c98ca", "#4b97c9", "#4a96c9", "#4895c8", "#4794c8", "#4693c7", "#4592c7", "#4492c6", "#4391c6", "#4190c5", "#408fc4", "#3f8ec4", "#3e8dc3", "#3d8cc3", "#3c8bc2", "#3b8ac2", "#3a89c1", "#3988c1", "#3787c0", "#3686c0", "#3585bf", "#3484bf", "#3383be", "#3282bd", "#3181bd", "#3080bc", "#2f7fbc", "#2e7ebb", "#2d7dbb", "#2c7cba", "#2b7bb9", "#2a7ab9", "#2979b8", "#2878b8", "#2777b7", "#2676b6", "#2574b6", "#2473b5", "#2372b4", "#2371b4", "#2270b3", "#216fb3", "#206eb2", "#1f6db1", "#1e6cb0", "#1d6bb0", "#1c6aaf", "#1c69ae", "#1b68ae", "#1a67ad", "#1966ac", "#1865ab", "#1864aa", "#1763aa", "#1662a9", "#1561a8", "#1560a7", "#145fa6", "#135ea5", "#135da4", "#125ca4", "#115ba3", "#115aa2", "#1059a1", "#1058a0", "#0f579f", "#0e569e", "#0e559d", "#0e549c", "#0d539a", "#0d5299", "#0c5198", "#0c5097", "#0b4f96", "#0b4e95", "#0b4d93", "#0b4c92", "#0a4b91", "#0a4a90", "#0a498e", "#0a488d", "#09478c", "#09468a", "#094589", "#094487", "#094386", "#094285", "#094183", "#084082", "#083e80", "#083d7f", "#083c7d", "#083b7c", "#083a7a", "#083979", "#083877", "#083776", "#083674", "#083573", "#083471", "#083370", "#08326e", "#08316d", "#08306b"].reverse();
    const spineColors = ["#fc9548", "#fc9346", "#fc9245", "#fc9143", "#fc9042", "#fb8f40", "#fb8e3f", "#fb8d3e", "#fb8c3c", "#fb8b3b", "#fa8a3a", "#fa8938", "#fa8837", "#fa8736", "#fa8534", "#f98433", "#f98332", "#f98230", "#f8812f", "#f8802e", "#f87f2c", "#f77e2b", "#f77d2a", "#f77b29", "#f67a27", "#f67926", "#f57825", "#f57724", "#f57623", "#f47522", "#f47420", "#f3731f", "#f3721e", "#f2701d", "#f26f1c", "#f16e1b", "#f16d1a", "#f06c19", "#f06b18", "#ef6a17", "#ef6916", "#ee6815", "#ed6714", "#ed6614", "#ec6513", "#ec6312", "#eb6211", "#ea6110", "#ea6010", "#e95f0f", "#e85e0e", "#e85d0e", "#e75c0d", "#e65b0c", "#e55a0c", "#e4590b", "#e4580b", "#e3570a", "#e25609", "#e15509", "#e05408", "#df5308", "#de5208", "#dd5207", "#dc5107", "#db5006", "#da4f06", "#d94e06", "#d84d05", "#d74c05", "#d64c05", "#d54b04", "#d44a04", "#d24904", "#d14804", "#d04804", "#cf4703", "#cd4603", "#cc4503", "#cb4503", "#c94403", "#c84303", "#c74303", "#c54203", "#c44103", "#c24102", "#c14002", "#bf3f02", "#be3f02", "#bd3e02", "#bb3e02", "#ba3d02", "#b83d02", "#b73c02", "#b53b02", "#b43b02", "#b23a03", "#b13a03", "#af3903", "#ae3903", "#ac3803", "#ab3803", "#aa3703", "#a83703", "#a73603", "#a53603", "#a43503", "#a33503", "#a13403", "#a03403", "#9f3303", "#9d3303", "#9c3203", "#9b3203", "#993103", "#983103", "#973003", "#953003", "#942f03", "#932f03", "#922e04", "#902e04", "#8f2d04", "#8e2d04", "#8d2c04", "#8b2c04", "#8a2b04", "#892b04", "#882a04", "#862a04", "#852904", "#842904", "#832804", "#812804", "#802704", "#7f2704"].reverse();
    const leafColors = ["#7ec980", "#7dc87f", "#7bc77e", "#7ac77c", "#78c67b", "#77c57a", "#75c479", "#74c478", "#72c378", "#71c277", "#6fc276", "#6ec175", "#6cc074", "#6bbf73", "#69bf72", "#68be71", "#66bd70", "#65bc6f", "#63bc6e", "#62bb6e", "#60ba6d", "#5eb96c", "#5db86b", "#5bb86a", "#5ab769", "#58b668", "#57b568", "#56b467", "#54b466", "#53b365", "#51b264", "#50b164", "#4eb063", "#4daf62", "#4caf61", "#4aae61", "#49ad60", "#48ac5f", "#46ab5e", "#45aa5d", "#44a95d", "#42a85c", "#41a75b", "#40a75a", "#3fa65a", "#3ea559", "#3ca458", "#3ba357", "#3aa257", "#39a156", "#38a055", "#379f54", "#369e54", "#359d53", "#349c52", "#339b51", "#329a50", "#319950", "#30984f", "#2f974e", "#2e964d", "#2d954d", "#2b944c", "#2a934b", "#29924a", "#28914a", "#279049", "#268f48", "#258f47", "#248e47", "#238d46", "#228c45", "#218b44", "#208a43", "#1f8943", "#1e8842", "#1d8741", "#1c8640", "#1b8540", "#1a843f", "#19833e", "#18823d", "#17813d", "#16803c", "#157f3b", "#147e3a", "#137d3a", "#127c39", "#117b38", "#107a37", "#107937", "#0f7836", "#0e7735", "#0d7634", "#0c7534", "#0b7433", "#0b7332", "#0a7232", "#097131", "#087030", "#086f2f", "#076e2f", "#066c2e", "#066b2d", "#056a2d", "#05692c", "#04682b", "#04672b", "#04662a", "#03642a", "#036329", "#026228", "#026128", "#026027", "#025e27", "#015d26", "#015c25", "#015b25", "#015a24", "#015824", "#015723", "#005623", "#005522", "#005321", "#005221", "#005120", "#005020", "#004e1f", "#004d1f", "#004c1e", "#004a1e", "#00491d", "#00481d", "#00471c", "#00451c", "#00441b"].reverse();

    let tofColorScale = null, spineColorScale = null, leafColorScale = null;

    const createColorScales = (data) => {
        let tofValueMin = Infinity, tofValueMax = -Infinity;
        let spineValueMin = Infinity, spineValueMax = -Infinity;
        let leafValueMin = Infinity, leafValueMax = -Infinity;

        data.nodes.forEach((item) => {
            const [nodeType, nodeNumber, lastNumber] = getNodeNumber(item.label);

            if (nodeType === "tof") {
                tofValueMin = Math.min(tofValueMin, nodeNumber);
                tofValueMax = Math.max(tofValueMax, nodeNumber * lastNumber);
            }
            if (nodeType === "spine") {
                spineValueMin = Math.min(spineValueMin, nodeNumber);
                spineValueMax = Math.max(spineValueMax, nodeNumber * lastNumber);
            }
            if (nodeType === "leaf") {
                leafValueMin = Math.min(leafValueMin, nodeNumber);
                leafValueMax = Math.max(leafValueMax, nodeNumber * lastNumber);
            }
        });

        tofColorScale = d3.scaleLinear()
            .domain([tofValueMin, tofValueMax])
            .range([0, tofColors.length - 1]);
        spineColorScale = d3.scaleLinear()
            .domain([spineValueMin, spineValueMax])
            .range([0, tofColors.length - 1]);
        leafColorScale = d3.scaleLinear()
            .domain([leafValueMin, leafValueMax])
            .range([0, tofColors.length - 1]);
    };
    const getNodeColor = (node) => {
        const [nodeType, nodeNumber, lastNumber] = getNodeNumber(node.label);

        if (nodeType === "tof")
            return tofColors[Math.floor(tofColorScale(nodeNumber * lastNumber))];

        if (nodeType === "spine")
            return spineColors[Math.floor(spineColorScale(nodeNumber * lastNumber))];

        if (nodeType === "leaf")
            return leafColors[Math.floor(leafColorScale(nodeNumber * lastNumber))];
    };
</script>

<script>
    const failedNode = "%FAILED_NODE%";
    const data = "%GRAPH%";

    filterLinks(data);

    const nodesByName = prepareData(data);
    createColorScales(data);

    let [minX, maxX, maxY, links] = setPositions(data);
    minX -= 30;
    const minY = -10;

    /* Main plot init */
    const tree = d3.select('#graph');

    const svg = tree.append('svg')
        .attr('width', "100%")
        .attr('height', "100%")
        .attr("viewBox", [minX, minY, maxX + Math.abs(minX), maxY - minY + 10])
        .call(d3.zoom()
            .on("zoom", () => {
                g.attr("transform", d3.event.transform);
            })
        );

    const g = svg.append('g')
        .attr('width', "100%")
        .attr('height', "100%");

    /* Node State plot */
    g.append("line")
        .attr("x1", minX)
        .attr("y1", 30)
        .attr("x2", minX)
        .attr("y2", maxY - 30)
        .attr("stroke-width", 1)
        .attr("stroke", "black");

    g.append('path')
        .attr("d", 'M ' + minX + ' ' + 30 + ' L ' + minX + ' ' + (maxY - 30))
        .attr("fill-opacity", 0)
        .attr("stroke-opacity", 0)
        .attr("id", "legend-path")
        .style("pointer-events", "none");

    g.append('text')
        .attr("dy", 4)
        .attr("fill", "black")
        .attr("font-size", "12px")
        .style("pointer-events", "none")
        .style("text-anchor", "middle")
        .append('textPath')
        .text("\u27A4")
        .attr("startOffset", "100%")
        .attr('xlink:href', "#legend-path")
        .style("pointer-events", "none");

    const edges = g.selectAll(".edges")
        .data(links)
        .enter()
        .append('path')
        .attr("class", "edges")
        .attr('d', e => {
            let path = '';
            for (let i = 0; i < e.path.length - 1; ++i)
                path += 'M ' + e.path[i].x + ' ' + e.path[i].y + ' L ' + e.path[i + 1].x + ' ' + e.path[i + 1].y;

            return path;
        })
        .attr("stroke-width", 1)
        .attr("stroke-dasharray", (d) => (d.source.label === failedNode || d.target.label === failedNode) ? "5,5" : "0,0")
        .attr("stroke", (d) => d.source.label === failedNode ? "#b80f0a" : getNodeColor(d.source));

    const edgesLabels = g.selectAll(".edgeslabels")
        .data(links.filter(d => d.source.label.search('-') !== -1))
        .enter()
        .append("text")
        .attr("class", "text-small edgeslabels")
        .attr("id", (d) => "edgelabel-" + d.source.label + "-" + d.target.label)
        .attr("x", (d) => d.path[1].x)
        .attr("y", (d) => d.path[1].y)
        .attr("fill", "white")
        .style('opacity', 0)
        .style('visibility', 'hidden')
        .style("text-anchor", "middle");
    edgesLabels.each((d, i, nodes) => {
        const currentNode = d3.select(nodes[i]);

        currentNode.selectAll('.edgelabel-tspan')
            .data(d.label)
            .enter()
            .append('tspan')
            .text(x => x.time + " | " + x.type)
            .attr('class', 'edgelabel-tspan')
            .attr('x', d.path[1].x)
            .attr('dy', (x, i) => (i > 0) ? 5 : 0);
    });

    const edgesLabelsShadow = g.selectAll(".edgeslabels-rect")
        .data(links.filter(d => d.source.label.search('-') !== -1))
        .enter()
        .insert('rect', 'text.edgeslabels')
        .attr('opacity', 0)
        .attr('class', 'edgelabel-rect')
        .attr('width', (d) => {
            const parentText = d3.select("#edgelabel-" + d.source.label + "-" + d.target.label).node();
            const textBoudingRect = parentText.getBBox();
            return textBoudingRect.width + 2;
        })
        .attr('height', (d) => {
            const parentText = d3.select("#edgelabel-" + d.source.label + "-" + d.target.label).node();
            const textBoudingRect = parentText.getBBox();
            return textBoudingRect.height + 2;
        })
        .attr('x', (d) => {
            const parentText = d3.select("#edgelabel-" + d.source.label + "-" + d.target.label).node();
            const textBoudingRect = parentText.getBBox();
            return textBoudingRect.x - 1;
        })
        .attr('y', (d) => {
            const parentText = d3.select("#edgelabel-" + d.source.label + "-" + d.target.label).node();
            const textBoudingRect = parentText.getBBox();
            return textBoudingRect.y - 1;
        })
        .style('visibility', 'hidden');

    const nodes = g.selectAll(".nodes")
        .data(data.nodes)
        .enter()
        .append("circle")
        .attr("class", "nodes")
        .attr("transform", (d) => `translate(${d.x}, ${d.y})`)
        .attr("r", 7)
        .attr("fill", (d) => d.label === failedNode ? "#b80f0a" : getNodeColor(d))
        .attr("fill-opacity", 0.95);

    const nodeLabelsShadow = g.selectAll(".nodelabels-shadow")
        .data(data.nodes)
        .enter()
        .append("text")
        .text((d) => getNodeNumber(d.label)[1])
        .attr("class", "text nodelabels-shadow")
        .attr("x", (d) => d.x)
        .attr("y", (d) => d.y)
        .attr("dy", 2.5)
        .attr("stroke", "black")
        .attr("stroke-width", 1)
        .attr("fill", "black")
        .style("text-anchor", "middle");

    const nodeLabels = g.selectAll(".nodelabels")
        .data(data.nodes)
        .enter()
        .append("text")
        .text((d) => getNodeNumber(d.label)[1])
        .attr("class", "text nodelabels")
        .attr("x", (d) => d.x)
        .attr("y", (d) => d.y)
        .attr("dy", 2.5)
        .attr("fill", "white")
        .style("text-anchor", "middle");

    /* Nodes Highlight */
    const transitionDuration = 250;
    const highlightNodeNeighbours = (nodesToHighlight, neighbours) => {
        nodes.transition()
            .duration(transitionDuration)
            .style('opacity', (d) => neighbours.find(y => y === d.label) !== undefined ? 0.95 : 0.1);

        nodeLabelsShadow.transition()
            .duration(transitionDuration)
            .style('opacity', (d) => neighbours.find(y => y === d.label) !== undefined ? 1 : 0.1);

        nodeLabels.transition()
            .duration(transitionDuration)
            .style('opacity', (d) => neighbours.find(y => y === d.label) !== undefined ? 1 : 0.1);

        edges.transition()
            .duration(transitionDuration)
            .style('opacity', (d) => (nodesToHighlight.find(y => y.label === d.source.label) !== undefined && neighbours.find(y => y === d.target.label) !== undefined) || (nodesToHighlight.find(y => y.label === d.target.label) !== undefined && neighbours.find(y => y === d.source.label) !== undefined) ? 1 : 0.1);
    };
    const highlightHover = (x) => {
        const neighbours = getNeighbors(data, x);
        highlightNodeNeighbours([x], neighbours);
    };
    const clearHover = () => {
        nodes.transition().duration(transitionDuration).style('opacity', 0.95);
        nodeLabelsShadow.transition().duration(transitionDuration).style('opacity', 1);
        nodeLabels.transition().duration(transitionDuration).style('opacity', 1);
        edges.transition().duration(transitionDuration).style('opacity', 1);
    };
    const clearFocus = () => {
        if(focused === null)
            return;

        focused = null;
        clearHover();

        edgesLabels.transition().duration(transitionDuration).style('opacity', 0).style('visibility', 'hidden');
        edgesLabelsShadow.transition().duration(transitionDuration).style('opacity', 0).style('visibility', 'hidden');

        hideOverlay();
    };

    let hovered = null;
    let focused = null;
    nodeLabels.on('mouseover', x => {
        hovered = x;

        if(focused !== null)
            return;

        highlightHover(x);
    });
    nodeLabels.on('mouseout', _ => {
        hovered = null;

        if(focused !== null)
            return;

        clearHover();
    });
    nodeLabels.on('click', x => {
        if (hovered === null)
            return;

        if(!d3.event.shiftKey) {
            /* Clear previous focus */
            if(focused !== null)
                clearFocus();

            highlightHover(hovered);

            focused = x;
            const neighbours = getNeighbors(data, x);
            showEdgeLabels([x], neighbours);
        } else
            showSameNumberNodes(x);
    });
    d3.select("body").on("keydown", () => {
        if(d3.event.keyCode === 67)
            clearFocus();
    });

    const showEdgeLabels = (nodesToHighlight, neighbours) => {
        if(focused === null)
            return;

        edgesLabels.transition()
            .duration(transitionDuration)
            .style('visibility', (d) => (nodesToHighlight.find(y => y.label === d.source.label) !== undefined && neighbours.find(y => y === d.target.label) !== undefined) || (nodesToHighlight.find(y => y.label === d.target.label) !== undefined && neighbours.find(y => y === d.source.label) !== undefined) ? 'visible' : 'hidden')
            .style('opacity', (d) => (nodesToHighlight.find(y => y.label === d.source.label) !== undefined && neighbours.find(y => y === d.target.label) !== undefined) || (nodesToHighlight.find(y => y.label === d.target.label) !== undefined && neighbours.find(y => y === d.source.label) !== undefined) ? 1 : 0);

        edgesLabelsShadow.transition()
            .duration(transitionDuration)
            .style('visibility', (d) => (nodesToHighlight.find(y => y.label === d.source.label) !== undefined && neighbours.find(y => y === d.target.label) !== undefined) || (nodesToHighlight.find(y => y.label === d.target.label) !== undefined && neighbours.find(y => y === d.source.label) !== undefined) ? 'visible' : 'hidden')
            .style('opacity', (d) => (nodesToHighlight.find(y => y.label === d.source.label) !== undefined && neighbours.find(y => y === d.target.label) !== undefined) || (nodesToHighlight.find(y => y.label === d.target.label) !== undefined && neighbours.find(y => y === d.source.label) !== undefined) ? 0.4 : 0);
    };

    const showSameNumberNodes = (x) => {
        const nodeNumber = getNodeNumber(x.label)[1];
        const sameNumberNodes = data.nodes.filter(node => getNodeNumber(node.label)[1] === nodeNumber);
        let nodeNeighbours = [];

        sameNumberNodes.forEach(node => {
            nodeNeighbours = nodeNeighbours.concat(getNeighbors(data, node))
        });

        highlightNodeNeighbours(sameNumberNodes, nodeNeighbours);
    };

    /* Edge Labels highlight */
    g.selectAll('.edgeslabels .edgelabel-tspan').on('click', x => {
        showOverlay(x);
    });
</script>

%OVERLAY_SCRIPT%
</body>
</html>